﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace N3
{
    class KonjObilazak
    {

        static void konjObilazak(int[][] mat, int popunjeno, int x, int y, int n)
        {
            mat[x][y] = popunjeno;
            if (popunjeno == n * n)
            {
                //popunili smo svih n*n brojeva, ispis resenja
                for (int i = 0; i < n; i++)
                {
                    for (int j = 0; j < n; j++)
                        Console.Write(mat[i][j] + " ");
                    Console.WriteLine();
                }
                Console.ReadLine();
                return;
            }

            int[] dxs = new int[] {2,2,-2,-2,1,-1,1,-1 };
            int[] dys = new int[] { 1, -1, 1, -1, 2, 2, -2, -2 };

            for (int i = 0; i < dxs.Length; i++)
            {
                int dx = dxs[i];
                int dy = dys[i];
                if (x + dx >= 0 && x + dx < n && y + dy >= 0 && y + dy < n && mat[x + dx][y + dy] == 0)
                {
                    konjObilazak(mat, popunjeno + 1, x + dx, y + dy, n);
                }
            }
            mat[x][y] = 0;
        }

        static void konjObilazakPoziv(int n, int x, int y){
            int[][] mat = new int[n][];
            for (int i = 0; i < n; i++)
                mat[i] = new int[n];

            konjObilazak(mat, 1, x, y, n);
        }

        static void Main(string[] args)
        {
            String nstr = Console.ReadLine();
            String xstr = Console.ReadLine();
            String ystr = Console.ReadLine();

            int n = Convert.ToInt32(nstr);
            int x = Convert.ToInt32(xstr);
            int y = Convert.ToInt32(ystr);

            konjObilazakPoziv(n, x, y);
        }
    }
}
